@ECHO OFF
PCHAR (15,@p,/ MCC.BAT ,@,/ --  Display all characters and attributes, $,(15,/ available within a BATCH file.,$$
PCHAR (15,@,/ WORKING.     Press any key to abort....,$$$,(7

:          INITIALIZATION OF ENVIRONMENT VARS.

:          1ST 9 ARE USED TO TRAP CHARS WHICH ARE NOT USEABLE
:          FROM WITHIN A BATCH FILE OR ARE PCHAR CONTROL CHARS.
:
:          RET = Return/Enter,  ESC = Esc KEY, SP = space.
:          W = DOS COMMAND PIPING SYMBOL (ascii 124).
:          X = Less than symbol, Y = Greater than symbol, Z = Percent sign.
:          DS = Dollar sign. (Pchar uses for return)
:          AT = @ sign.      (Pchar uses for Attribute control char)
SET RET=d
SET ESC=d
SET SP=!
SET DS=$
SET AT=@
SET CM=,
SET W={
SET X=d
SET Y=d
SET Z=d

:          The next 5 Environment vars are used by MCC.BAT to control
:          which character to add to LINE and which attribute to display
:          it with.  The variable DONE_FLAG is set to ascii 255.
:          When the CHAR var is = to DONE_FLAG, DONE_FLAG is set to 1 and
:          MCC terminates.  The variable L_CNT (set = A) is compared to
:          a constant (O).  O=79 in ascii, A=65 in ascii, 79-65=14.
:          If L_CNT > O then LINE has 45 characters.  15 * 3.
:          For each value of CHAR, 3 characters are appended to LINE.
:          A @ sign (PCHAR uses next byte as attribute), and 2 copies
:          of CHAR.  1 for the attribute and 1 to display.
:          It is then written to the screen by PCHAR and reset to empty.

SET CHAR=1
SET DONE_FLAG=
SET L_CNT=A
SET C_CNT=A
SET LINE=?

:          This call to BVAR calculates the initial values we need for
:          the variables used to hold non-displayable chars.
:          It also sets CHAR=ascii(255) so that next INC of char
:          will result in an ascii(1).  ATR is set = to char and INC'ed
:          to be ascii(1).  The # operator removes 1 char from the last
:          environment var SET (LINE) so that it is empty.

BVAR ESC-/I,CHAR-/1,RET-/W,W,X-/(,Y-/&,Z-/?,-SP,#

:ML

MCCCOM

:W_LINE
:          This call to PCHAR displays LINE on the screen.
:                     (LINE contains a PCHAR command line.)
PCHAR /      ,%LINE%
BVAR C_CNT,C_CNT$/D,C_CNT=/A
IF ERRORLEVEL 1 GOTO NOPOS

PCHAR $,(7

:NOPOS

:          The next 2 lines reset the variable LINE to empty,
:          resets L_CNT = to A, and compares DONE_FLAG TO 1.
:          If it is equal, MCC terminates.

SET LINE=?
BVAR #,L_CNT=/A,DONE_FLAG$/1
IF NOT ERRORLEVEL 1 GOTO DONE

:          This line checks to see if a key has been hit (ERRORLEVEL 1)
:          Terminates if true.

KEYHIT
IF ERRORLEVEL 1 GOTO DONE

GOTO ML

:DONE
:          Remove all variables used by MCC.BAT from environment.
:          Always a good idea.  Helps avoid out of envrionment space errors.

SET CHAR=
SET L_CNT=
SET LINE=
SET DONE_FLAG=
SET CM=
SET AT=
SET DS=
SET RET=
SET ESC=
SET SP=
SET W=
SET X=
SET Y=
SET Z=
